---
title: Server Architecture
---

# /packages/server

## src/api/

Contains Express Router() instances for API endpoints (loaded by `lib/Express.ts`)

## src/lib/

Contains majority of modules

## src/models/

Wrappers for database objects to add extra utilities

## src/tools/

Scripts that are compiled to `.js` at build time and are accessable by `npm run tool` (see [tool.sh](#toolsh))

## src/workers/

Houses worker source files that are run by nodejs worker threads

## src/jobs/

Contains automated jobs

## tool.sh

Utility used by the `tool` script, used to execute tools from `src/tools/` based on runtime (eg. development or production)

> `npm run tool init_settings` will run one of the following:
>
> - if `NODE_ENV` is `production`: `dist/tools/init_settings.js`
> - else: `src/tools/init_settings.ts`
