export class CanvasUtils {
  static canvasToPanZoomTransform(
    x: number,
    y: number,
    canvas: [width: number, height: number],
    useZoom: boolean
  ) {
    let transformX = 0;
    let transformY = 0;

    if (useZoom) {
      // CSS Zoom does not alter this (obviously)
      transformX = canvas[0] / 2 - x;
      transformY = canvas[1] / 2 - y;
    } else {
      transformX = canvas[0] / 2 - x;
      transformY = canvas[1] / 2 - y;
    }

    return { transformX, transformY };
  }
}
